// gis2007.cpp : ̨Ӧóڵ㡣
//

#include "stdafx.h"
#include "source/glsl.h"
#include "gl/glut.h"
#include "fbohelp.h"
#include "graphicProcessor.h"
using namespace cwc;


const char vs[] = "#version 110\n"                 \
"void main(void)"                                           \
"{"                                                         \
"   gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;"\
"}";

const char ps[] = "uniform sampler2DRect x;"\
"void main (void)"\
"{"\
"gl_FragColor = texture2DRect(x, gl_TexCoord[0].st);"\
"}";

glShader* pshader;

class MyKernel : public Kernel
{
	glShaderManager glsm_;
	glShader*			pshader_;

public:
	MyKernel(){
		pshader_ = glsm_.loadfromMemory(NULL, ps);
	}

	void CreateKernelEnv()
	{
		pshader_->begin();

		pshader_->setUniform1i("x", 0);
	}

	void DestoryKernelEnv()
	{
		pshader_->end();
	}

};

int _tmain(int argc, _TCHAR* argv[])
{
	
	float test[256];
	for(int i = 0; i < 256; ++i){test[i] = i * 0.01;}

	float out[256];
	
	GraphicProcessor gp(256);
	MyKernel mk;

	gp.RegisterKernel(&mk);
	
	vector<GLuint> texIDs = gp.AllocMems(2);
	gp.WriteMem(test, texIDs[0]);

	gp.RegisterMemBlock(texIDs[0], 0);
	gp.PerformComputation(texIDs[1]);

	gp.ReadBuffer(out);
	gp.FreeMems(texIDs);
	//performComputation(texIDs[1], 1, &(texIDs[0]), &mk);
		
	//transferFromTexture(out);

	printVector(out, 256);
	// exit
	system("pause");
	return 0;
}

